<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_8</title>
</head>
<body>
    <h1>Capitulo 8</h1>
    <a>Ejercicio 11</a>

    <script>
    
        function pilaDeCjas(n, caja) {
     
            let occ = new Map();
            for(let i = 0; i < n; i++) {
                occ.set(caja[i], occ.get(caja[i]) == null 
                                ? 1 
                                : occ.get(caja[i]) + 1);
            }
 
            let pila = 0;
            while (occ.size != 0) {
                pila++;
                let size = 0;
                let apilar = new Set();

                for(let [key, value] of occ.entries()) {
                    let mx = key,
                        ct = value,
                       use = Math.min(ct, mx - size + 1);
 
                    occ.set(mx, occ.get(mx) - use);
                    size += use;
             
                    if (occ.get(mx) == 0) {
                        apilar.add(mx);
                    }
                }

                for(let tm of apilar.values()) {
                    occ.delete(tm);
                }
            }
            return pila;
        }
 
        let caja = [ 0, 0, 1, 1, 2 ];
        let n = caja.length;
 
        console.log(`La altra maxima de la pila de cajas es: ${pilaDeCjas(n, caja)}`);
 
        
        
</script>
    
</body>
</html>